
gene={}
with open('transcripts.gtf') as fin:
	for line in fin:
		lst=line.rstrip().split('\t')
		if lst[2]=='transcript':
			gene[lst[8].split('; ')[1].split()[1].replace('"','')]=[lst[0],int(lst[3]),int(lst[4]),lst[6],[],[]]


with open('best_candidates.gff3') as fin:
	for line in fin:
		lst=line.rstrip().split('\t')
		if len(lst)<9:
			continue
		if lst[2]=='CDS':
			n=gene[lst[0]]
			n[4].append(n[1]+int(lst[3])-2)
			n[5].append(n[1]+int(lst[4])-1)


fout=open('orf','w')
fout2=open('orf.struct','w')
id=1
for n in gene:
	if len(gene[n][4])==0: continue
	fout.write('{0}\t{1}\t{2}\t{3}\t{4}\t{5}\n'.format(gene[n][0],
		gene[n][1],
		gene[n][2],
		n,
		id,
		gene[n][3]))
	start=max(gene[n][4])
	stop=min(gene[n][5])
	fout2.write('{0}\t{1}\t{2}\t{3}\t{4}\t{5}\t{6}\t{7}\t{8}\t{9}\t{10}\n'.format(
		id,
		gene[n][0],
		gene[n][3],
		start,
		stop,
		start,
		stop,
		len(gene[n][4]),
		','.join([str(i) for i in gene[n][4]]),
		','.join([str(i) for i in gene[n][5]]),
		n))
	id+=1
fout.close()
fout2.close()


import os
os.system('sort -k1,1 -k2,2n orf > xx')
os.system('mv xx orf')
os.system('bgzip orf')
os.system('tabix -p bed orf.gz')


print '''
drop table if exists orfstruct;
create table orfstruct (
id int unsigned not null primary key,
chrom varchar(255) not null,
strand char(1) not null,
txStart int unsigned not null,
txEnd int unsigned not null,
cdsStart int unsigned not null,
cdsEnd int unsigned not null,
exonCount int unsigned not null,
exonStarts text not null,
exonEnds text not null,
name varchar(255) not null
);
load data local infile 'orf.struct' into table orfstruct;


drop table if exists orfsymbol;
create table orfsymbol (
name varchar(255) not null,
symbol varchar(255) null,
description text null,
id int unsigned not null primary key,
index(name)
);
'''

